#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <errno.h>
#include <sys/wait.h>

void sig_handler(int sig)
{
	fprintf(stderr, "signal: %d\n", sig);
}

int main()
{
	int fd[2];
	char buf[1024];
	int ret;
	int i;

	ret = pipe(fd);
	if (ret == -1) {
		perror("pipe()");
		exit(-1);
	}

	ret = fork();
	if (ret < 0) {
		perror("fork()");
		exit(-1);
	}
	if (ret) { /* Parent */
		close(fd[0]);
		usleep(100000);
		close(fd[1]);
		wait(NULL);
		return 0;
	}

	/* Child */
	for (i=0; i<100; i++) {
		signal(i, sig_handler);
	}

	close(fd[1]);
	errno = 0;
	ret = read(fd[0], buf, sizeof(buf));
	fprintf(stderr, "R: %d\n", ret);
	if (ret <= 0) {
		perror("read()");
	}
	close(fd[0]);
	
	return 0;
}

