#include <stdio.h>
#include <stdlib.h>
#ifdef __FreeBSD__
#include <libutil.h>
#else
#include <pty.h>
#endif
#include <unistd.h>
#include <signal.h>
#include <errno.h>
#include <sys/wait.h>

void sig_handler(int sig)
{
	fprintf(stderr, "signal: %d\n", sig);
}

int main()
{
	int master, slave;
	char buf[1024];
	int ret;
	int i;

	ret = openpty(&master, &slave, NULL, NULL, NULL);
	if (ret == -1) {
		perror("openpty()");
		exit(-1);
	}

	ret = fork();
	if (ret < 0) {
		perror("fork()");
		exit(-1);
	}
	if (ret) { /* Parent */
		close(slave);
		usleep(100000);
		close(master);
		wait(NULL);
		return 0;
	}

	/* Child */
	for (i=0; i<100; i++) {
		signal(i, sig_handler);
	}

	close(master);
	errno = 0;
	ret = read(slave, buf, sizeof(buf));
	fprintf(stderr, "SR: %d\n", ret);
	if (ret <= 0) {
		perror("read()");
	}
	close(slave);
	
	return 0;
}

