#include <stdio.h>
#include <stdlib.h>
#ifdef __FreeBSD__
#include <libutil.h>
#else
#include <pty.h>
#endif
#include <unistd.h>
#include <signal.h>
#include <errno.h>

void sig_handler(int sig)
{
	fprintf(stderr, "signal: %d\n", sig);
}

int main()
{
	int master, slave;
	int ret;
	int i;

	ret = openpty(&master, &slave, NULL, NULL, NULL);
	if (ret == -1) {
		perror("openpty()");
		exit(-1);
	}

	for (i=0; i<100; i++) {
		signal(i, sig_handler);
	}

	close(master);
	errno = 0;
	ret = write(slave, "0123456789\n", 11);
	fprintf(stderr, "SW: %d\n", ret);
	if (ret <= 0) {
		perror("write()");
	}
	close(slave);
	
	return 0;
}

